=== debian/changelog ===
prometheus-snmp-exporter (0.30.1-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches

 -- Daniel Swarbrick <dswarbrick@debian.org>  Fri, 09 Jan 2026 17:10:49 +0000
